import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

/**
 * 
 */

/**
 * @author w.klaas
 *
 */
public class LimitLinesDocumentFilterTest {
	private static JTextArea textarea;
	private static int count = 0;

	private static void createAndShowUI() {
		int rows = 10;
		int cols = 30;
		textarea = new JTextArea(rows, cols);
		PlainDocument doc = (PlainDocument) textarea.getDocument();
		int maxLineCount = 1000;
		doc.setDocumentFilter(new LimitLinesDocumentFilter(maxLineCount));

		JFrame frame = new JFrame("Limit Lines Document Filter Test");
		frame.getContentPane().setLayout(new FlowLayout());
		frame.getContentPane().add(new JScrollPane(textarea));
		JButton jButton = new JButton("1000 Lines more");
		jButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				addLines();
			}
		});
		frame.getContentPane().add(jButton);
		JButton jButton1 = new JButton("GC");
		jButton1.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				System.gc();
			}
		});
		frame.getContentPane().add(jButton1);
		JButton jButton2 = new JButton("Clear");
		jButton2.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				textarea.setText("");
			}
		});
		frame.getContentPane().add(jButton2);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.setLocationRelativeTo(null);
		frame.setVisible(true);

		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				addLines();
			}
		});

	}

	protected static void addLines() {
		Thread thread = new Thread(new Runnable() {

			@Override
			public void run() {
				int maxcount = 10000;
				while (maxcount > 0) {
					maxcount--;
					final String line = String.format(
							"Dies ist Zeile %1$d %2$d\n\r", count++, textarea
									.getDocument().getLength());
					java.awt.EventQueue.invokeLater(new Runnable() {
						public void run() {
							textarea.append(line);
							textarea.setCaretPosition(textarea.getDocument()
									.getLength());
						}
					});
					Thread.yield();
					try {
						Thread.sleep(1);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
		});
		thread.start();
	}

	public static void main(String[] args) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				createAndShowUI();
			}
		});
	}
}
